// ViewView.cpp : implementation of the CViewView class
//

#include "stdafx.h"
#include "View.h"

#include "ViewDoc.h"
#include "ViewView.h"

#include "eva4cap.h"

//#include <mmsystem.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
// change this parameter for the proper display screen
#define	DOT_START	24
#define DWIDTH		640
#define DHEIGHT		480

///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////

#define WIDTH	DWIDTH
#define HEIGHT	DHEIGHT
#define	FRAMES	2
#define	COLORS	2


#define Video	0

#define MAX_CHANNELS	4

///////////////////////////////////////////////////////////////

BYTE image[DWIDTH*DHEIGHT*3];
BOOL bFlagDisplay = FALSE;

BYTE *rawImage[MAX_CHANNELS];

DWORD tImage[(DWIDTH*DHEIGHT)];

///////////////////////////////////////////////////////////////////
CRect rectImage(5, 5, DWIDTH+5, DHEIGHT+5);



///////////////////////////////////////////////////////////////////
//
//
// image functions
//
///////////////////////////////////////////////////////////////////

#define SAA7113_DATA_NUMS   24 

BYTE SAA7113data[SAA7113_DATA_NUMS] = 
	{
	0x0,
	0x8,
	0xc0,
	0x33,
	0x0,
	0x0,
	0xe9,
	0x0d,

	0x98,
	0x01,
	0x80,
	0x47,
	0x40,
	0x0,
	0x1,
	0x2a,

	0x40,
	0xc,
	0x01,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
};

void saa7113_setup()
{
	EVA_I2cInit();
	EVA_I2cWrite(0,0x48,0,24,SAA7113data);	// channel 1
	EVA_I2cWrite(0,0x4a,0,24,SAA7113data);	// channel 2
	EVA_I2cWrite(1,0x48,0,24,SAA7113data);	// channel 3
	EVA_I2cWrite(1,0x4a,0,24,SAA7113data);	// channel 4
}	

void SaveRawImage(BYTE *buf)
{
	FILE *fp;
	fp = fopen("data.raw","wb");
	fwrite(buf,WIDTH,HEIGHT,fp);	// 8bit
	fclose(fp);
}


///////////////////////////////////////////////////////////////////

UINT ThreadFunc(LPVOID lpData){

	DWORD data;

	CViewView *pView = (CViewView *)lpData;

	DWORD pos,disppos=0;

	EVA_SetCapMode(0,DOT_START,WIDTH,HEIGHT,FRAMES,1,pView->m_VMode);
	EVA_SetCapMode(1,DOT_START,WIDTH,HEIGHT,FRAMES,1,pView->m_VMode);
	EVA_SetCapMode(2,DOT_START,WIDTH,HEIGHT,FRAMES,1,pView->m_VMode);
	EVA_SetCapMode(3,DOT_START,WIDTH,HEIGHT,FRAMES,1,pView->m_VMode);

	EVA_DmaCapStart(0);
	EVA_DmaCapStart(1);
	EVA_DmaCapStart(2);
	EVA_DmaCapStart(3);

	// real capture start at the next v-sync
	EVA_CapEnable(0xf);	// capture enablle

	int ch = 0;
	int cnt = 0;

	while(bFlagDisplay == TRUE){

		EVA_GetDmaPosOvl(0,&pos);
		if (pos==1) pos=2;
		else pos = 1;

		//Sleep(20);
		cnt++;
		if (cnt==60) {
			cnt = 0;
			ch++;
			if (ch==4) ch=0;
		}

		pView->dispChannel = ch;
		EVA_RAWtoBMPImage(pView->dispChannel,(BYTE *)rawImage[pView->dispChannel],image,pos);
		pView->InvalidateRect(&rectImage, FALSE);
		disppos = pos;
		//if (pos==1) break;
	}

	EVA_DmaStop(0);
	EVA_DmaStop(1);
	EVA_DmaStop(2);
	EVA_DmaStop(3);

	EVA_CapEnable(0);	// capture enablle

	SaveRawImage(rawImage[0]);
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CViewView

IMPLEMENT_DYNCREATE(CViewView, CFormView)

BEGIN_MESSAGE_MAP(CViewView, CFormView)
	//{{AFX_MSG_MAP(CViewView)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_COMMAND(ID_MENU_D1, OnMenuD1)
	ON_COMMAND(ID_MENU_D2, OnMenuD2)
	ON_COMMAND(ID_MENU_F_C_I, OnMenuF_C_I)
	ON_COMMAND(ID_MENU_F_C_NI, OnMenuF_C_NI)
	ON_COMMAND(ID_MENU_F_M_I, OnMenuF_M_I)
	ON_COMMAND(ID_MENU_F_M_NI, OnMenuF_M_NI)
	ON_COMMAND(ID_MENU_H_C_O, OnMenuH_C_O)
	ON_COMMAND(ID_MENU_H_M_O, OnMenuH_M_O)
	ON_COMMAND(ID_MENU_H_C_E, OnMenuH_C_E)
	ON_COMMAND(ID_MENU_H_M_E, OnMenuH_M_E)
	ON_COMMAND(ID_MENU_H_C_OE, OnMenuH_C_OE)
	ON_COMMAND(ID_MENU_H_M_OE, OnMenuH_M_OE)
	//}}AFX_MSG_MAP

	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CViewView construction/destruction


CViewView::CViewView()
	: CFormView(CViewView::IDD)
{
	//{{AFX_DATA_INIT(CViewView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_VMode = 0;
	m_DMode = 0;
	dispChannel = 0;

	EVA_Init();

	rawImage[0] = (BYTE *)EVA_DmaAlloc(0,WIDTH*HEIGHT*FRAMES*2);
	rawImage[1] = (BYTE *)EVA_DmaAlloc(1,WIDTH*HEIGHT*FRAMES*2);
	rawImage[2] = (BYTE *)EVA_DmaAlloc(2,WIDTH*HEIGHT*FRAMES*2);
	rawImage[3] = (BYTE *)EVA_DmaAlloc(3,WIDTH*HEIGHT*FRAMES*2);
	saa7113_setup();
}

CViewView::~CViewView()
{
	EVA_DmaStop(0);
	EVA_DmaStop(1);
	EVA_DmaStop(2);
	EVA_DmaStop(3);
	EVA_End();
}

void CViewView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CViewView)
	DDX_Control(pDX, IDC_BUTTON1, m_bnBegin);
	//}}AFX_DATA_MAP
}

BOOL CViewView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CViewView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

}

/////////////////////////////////////////////////////////////////////////////
// CViewView diagnostics

#ifdef _DEBUG
void CViewView::AssertValid() const
{
	CFormView::AssertValid();
}

void CViewView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CViewDoc* CViewView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CViewDoc)));
	return (CViewDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CViewView message handlers

void CViewView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	BITMAPINFOHEADER m_bmiHdr;
	BITMAPFILEHEADER m_bmfHdr;

	EVA_MakeBMPHeaderCh(dispChannel,&m_bmiHdr, &m_bmfHdr);
	SetDIBitsToDevice(dc.m_hDC, 5, 5,	m_bmiHdr.biWidth, m_bmiHdr.biHeight,
						0, 0, 0, (WORD)m_bmiHdr.biHeight, image,
						(LPBITMAPINFO)&m_bmiHdr, BI_RGB);

}

void CViewView::OnButton1() 
{

	if ( bFlagDisplay == FALSE ) {
		bFlagDisplay = TRUE;
		AfxBeginThread(ThreadFunc, (LPVOID)this, THREAD_PRIORITY_NORMAL);
		m_bnBegin.SetWindowText("Stop");
	}
	else {
		bFlagDisplay = FALSE;
		m_bnBegin.SetWindowText("Display");
	}
}

void CViewView::OnMenuD1() 
{
	// TODO: Add your command handler code here
	m_DMode = 0;	
}

void CViewView::OnMenuD2() 
{
	// TODO: Add your command handler code here
	m_DMode = 1;	

}


void CViewView::OnMenuF_C_I()
{
	m_VMode = 0;
}

void CViewView::OnMenuF_C_NI()
{
	m_VMode = 1;
}

void CViewView::OnMenuF_M_I()
{
	m_VMode = 2;
}

void CViewView::OnMenuF_M_NI()
{
	m_VMode = 3;

}

void CViewView::OnMenuH_C_O()
{
	m_VMode = 4;

}
void CViewView::OnMenuH_M_O()
{
	m_VMode = 5;

}
void CViewView::OnMenuH_C_E()
{
	m_VMode = 6;

}
void CViewView::OnMenuH_M_E()
{
	m_VMode = 7;

}
void CViewView::OnMenuH_C_OE()
{
	m_VMode = 8;

}
void CViewView::OnMenuH_M_OE()
{
	m_VMode = 9;

}

